// Attract-Mode Front-End - "Game Monitor" - FrizzleFried
// Visit my home arcade blogsite - www.idahogaragecade.com

// Layout options

class UserConfig
{ 
</ label="Toggle Games List", help="Toggle games list scrolling format",options="Advanced,Simple,Logo", order=1 /> gamelist="Advanced";
</ label="Advanced List Sel. Text Color", help="Toggle advanced text games list selected list color",options="Yellow,Blue,Black,White", order=6 /> glsel="Yellow";
</ label="Advanced List Non-Sel. Text Color", help="Toggle advanced text games list non-selected list color",options="White,Black,Yellow,Blue", order=7 /> glunsel="White";
</ label="Text or Logo Fade", help="Toggle advanced text or logo games list fade",options="Off,On", order=5 /> glfade="Off";
</ label="Text or Logo Speed", help="Toggle advanced text or logo games list speed",options="Fastest,Fast,Medium,Slow,Slowest", order=4 /> glspeed="Medium";
</ label="Toggle Logo Border", help="Toggle Logo games list border",options="No Border,Border", order=8 /> logob="No Border";
}
local my_config = fe.get_config();

// Set up art and text elements

fe.layout.width = 720;
fe.layout.height = 480;
fe.layout.font = "captain"
fe.add_image( "glbg2.png", 0, 0, 720, 480 );

// Configurable Game List - uses the Conveyor_Helper module by ArcadeBliss (http://forum.attractmode.org/index.php?topic=1945.0)

fe.do_nut( "scripts/conveyor_helper.nut" );

if ( my_config["gamelist"] == "Advanced" )
{
	local glist = MyGameList();
	
	glist.x = 560;											// OPTIONS: top left x-coordinate if gamelist is linear or the center x-coordinate if a spinwheel
	glist.y = 0;											// OPTIONS: top left y-coordinate if gamelist is linear or the center y-coordinate if a spinwheel
	glist.width = 140; 										// OPTIONS: linear game list total width in pixels
	glist.height = 480; 									// OPTIONS: linear list's height in pixels
	glist.type = ch.Linear_Vertical							// OPTIONS: ch.Spinwheel / ch.Linear_Vertical / ch.Linear_Horizontal
	
	if ( my_config["glspeed"] == "Fastest" )
	{
		glist.ms_speed = 50;								// OPTIONS: in milliseconds, sets the speed of the conveyor
	}
	if ( my_config["glspeed"] == "Fast" )
	{
		glist.ms_speed = 115;								// OPTIONS: in milliseconds, sets the speed of the conveyor
	}
	if ( my_config["glspeed"] == "Medium" )
	{
		glist.ms_speed = 160;								// OPTIONS: in milliseconds, sets the speed of the conveyor
	}
	if ( my_config["glspeed"] == "Slow" )
	{
		glist.ms_speed = 240;								// OPTIONS: in milliseconds, sets the speed of the conveyor
	}
	if ( my_config["glspeed"] == "Slowest" )
	{
		glist.ms_speed = 325;								// OPTIONS: in milliseconds, sets the speed of the conveyor
	}

	glist.fade_after_nav = 255;							// OPTIONS: 0-255 Fades the entire gamelist's alpha channel after navigation to this value. set to 255 to disable fading
	glist.fade_delay = 5000; 							// the amount of time in milliseconds before the fade should start
	glist.fade_speed = 5.0; 							// the mulitplier controlling the speed of the fade
	glist.fade_selected = false;					 	// OPTIONS: TRUE/FALSE fade selected game if gamelist fading is active
		
	glist.linear.padding = 5;								// the amount of padding in pixels between each gamelist item
	
	glist.item.contentTemplate = ch.Text;					// OPTIONS: ch.Artwork / ch.Text / ch.Artwork_and_Text / ch.Artwork_or_Text / ch.Flyer_and_Artwork 
	glist.item.count = 15;									// OPTIONS: Total number of gamelist items to display
	
	glist.text.alignment = Align.Centre;					// OPTIONS:left/right/center
	
	if ( my_config["glunsel"] == "White" )
	{
		glist.text.normal.font = "captain";
		glist.text.normal.size = 12;						// OPTIONS: text font size for every gameList item
		glist.text.normal.color.red = 255;					// OPTIONS: text font red color channel 0 - 255
		glist.text.normal.color.green = 255;				// OPTIONS: text font green color channel 0 - 255
		glist.text.normal.color.blue = 255;					// OPTIONS: text font blue color channel 0 - 255
	}
	
	if ( my_config["glunsel"] == "Black" )
	{
		glist.text.normal.font = "captain";
		glist.text.normal.size = 12;						// OPTIONS: text font size for every gameList item
		glist.text.normal.color.red = 0;					// OPTIONS: text font red color channel 0 - 255
		glist.text.normal.color.green = 0;					// OPTIONS: text font green color channel 0 - 255
		glist.text.normal.color.blue = 0;					// OPTIONS: text font blue color channel 0 - 255
	}
	
	if ( my_config["glunsel"] == "Yellow" )
	{
		glist.text.normal.font = "captain";
		glist.text.normal.size = 12;						// OPTIONS: text font size for every gameList item
		glist.text.normal.color.red = 255;					// OPTIONS: text font red color channel 0 - 255
		glist.text.normal.color.green = 255;				// OPTIONS: text font green color channel 0 - 255
		glist.text.normal.color.blue = 0;					// OPTIONS: text font blue color channel 0 - 255
	}
	
	if ( my_config["glunsel"] == "Blue" )
	{
		glist.text.normal.font = "captain";
		glist.text.normal.size = 12;						// OPTIONS: text font size for every gameList item
		glist.text.normal.color.red = 40;					// OPTIONS: text font red color channel 0 - 255
		glist.text.normal.color.green = 64;			 		// OPTIONS: text font green color channel 0 - 255
		glist.text.normal.color.blue = 154;					// OPTIONS: text font blue color channel 0 - 255
	}
	
	if ( my_config["glsel"] == "Yellow" )
	{
		glist.text.currentlySelected.font = "captain";
		glist.text.currentlySelected.size = 16; 			// OPTIONS: text font size for every gameList item
		glist.text.currentlySelected.color.red = 255;		// OPTIONS: text font red color channel 0 - 255
		glist.text.currentlySelected.color.green = 255; 	// OPTIONS: text font green color channel 0 - 255
		glist.text.currentlySelected.color.blue = 0;   		// OPTIONS: text font blue color channel 0 - 255
	}
	if ( my_config["glsel"] == "Blue" )
	{
		glist.text.currentlySelected.font = "captain";
		glist.text.currentlySelected.size = 16; 			// OPTIONS: text font size for every gameList item
		glist.text.currentlySelected.color.red = 45;		// OPTIONS: text font red color channel 0 - 255
		glist.text.currentlySelected.color.green = 64; 		// OPTIONS: text font green color channel 0 - 255
		glist.text.currentlySelected.color.blue = 154;   	// OPTIONS: text font blue color channel 0 - 255
	}
	if ( my_config["glsel"] == "Black" )
	{
		glist.text.currentlySelected.font = "captain";
		glist.text.currentlySelected.size = 16; 			// OPTIONS: text font size for every gameList item
		glist.text.currentlySelected.color.red = 0;			// OPTIONS: text font red color channel 0 - 255
		glist.text.currentlySelected.color.green = 0; 		// OPTIONS: text font green color channel 0 - 255
		glist.text.currentlySelected.color.blue = 0;   		// OPTIONS: text font blue color channel 0 - 255
	}
	if ( my_config["glsel"] == "White" )
	{
		glist.text.currentlySelected.font = "captain";
		glist.text.currentlySelected.size = 16; 			// OPTIONS: text font size for every gameList item
		glist.text.currentlySelected.color.red = 255;		// OPTIONS: text font red color channel 0 - 255
		glist.text.currentlySelected.color.green = 255; 	// OPTIONS: text font green color channel 0 - 255
		glist.text.currentlySelected.color.blue = 255;   	// OPTIONS: text font blue color channel 0 - 255
	}
	
	glist.item.sizeScaling.low = 1.00; 						// OPTIONS: 0-100 Scaling size percentage to use for the item furthest from the selected item 
	glist.item.sizeScaling.high = 1.00; 					// OPTIONS: 0-100 Scaling size percentage to use for item closest to the selected item
	glist.item.sizeScaling.currentlySelected = 1.00;		// OPTIONS: 0-100 Scaling size percentage to use for the currently selected item
        		
	glist.item.alphaScaling.low = 50; 						// OPTIONS: 0-100 Scaling size percentage to use for the item furthest from the selected item 
	glist.item.alphaScaling.high = 210; 					// OPTIONS: 0-100 Scaling size percentage to use for item closest to the selected item
	glist.item.alphaScaling.currentlySelected = 255;		// OPTIONS: 0-100 Scaling size percentage to use for the currently selected item
        
	glist.item.height = 90;						 			// OPTIONS: Height of each gameList item in pixels before scaling - dynamic with linear vertical lists
	glist.item.width = 140;									// OPTIONS: Width of each gameList item in pixels before scaling - dynamic with linear horizontal lists
        
	glist.item.margin.left = 1; 							// OPTION: bounding box left margin size for all images and text 
	glist.item.margin.right = 1; 							// OPTION: bounding box right margin size for all images and text
	glist.item.margin.top = 1;								// OPTION: bounding box top margin size for all images and text
	glist.item.margin.bottom = 1;							// OPTION: bounding box bottom margin size for all images and text

	glist.item.toggle.glossOverlay = false;					// if set to "TRUE" will overlay the game item with a gloss file (file: item_glossOverlay.png)
	glist.item.toggle.borderOverlay = false;				// if set to "TRUE" will overlay the game item with a boarder file (file: item_borderOverlay.png)

	glist.show ();
}

if ( my_config["gamelist"] == "Logo" )
{
	local glist = MyGameList();

		glist.type = ch.Linear_Vertical; 					// OPTIONS: ch.Spinwheel / ch.Linear_Vertical / ch.Linear_Horizontal
		glist.bend.direction = ch.Right;					// OPTIONS: ch.Left / ch.Right
		glist.bend.gl_radius = 0
		glist.x = 562;										// OPTIONS: top left x-coordinate if gamelist is linear or the center x-coordinate if a spinwheel
		glist.y = 35;										// OPTIONS: top left y-coordinate if gamelist is linear or the center y-coordinate if a spinwheel
		glist.width = 136; 									// OPTIONS: linear game list total width in pixels
		glist.height = 475; 								// OPTIONS: linear list's height in pixels
	if ( my_config["glspeed"] == "Fastest" )
	{
		glist.ms_speed = 40;								// OPTIONS: in milliseconds, sets the speed of the conveyor
	}
	if ( my_config["glspeed"] == "Fast" )
	{
		glist.ms_speed = 100;								// OPTIONS: in milliseconds, sets the speed of the conveyor
	}
	if ( my_config["glspeed"] == "Medium" )
	{
		glist.ms_speed = 150;								// OPTIONS: in milliseconds, sets the speed of the conveyor
	}
	if ( my_config["glspeed"] == "Slow" )
	{
		glist.ms_speed = 225;								// OPTIONS: in milliseconds, sets the speed of the conveyor
	}
	if ( my_config["glspeed"] == "Slowest" )
	{
		glist.ms_speed = 300;								// OPTIONS: in milliseconds, sets the speed of the conveyor
	}		

	glist.fade_after_nav = 255;							// OPTIONS: 0-255 Fades the entire gamelist's alpha channel after navigation to this value. set to 255 to disable fading
	glist.fade_delay = 5000; 							// the amount of time in milliseconds before the fade should start
	glist.fade_speed = 5.0; 							// the mulitplier controlling the speed of the fade
	glist.fade_selected = false;					 	// OPTIONS: TRUE/FALSE fade selected game if gamelist fading is active
		
	glist.linear.padding = 26;								// the amount of padding in pixels between each gamelist item
	
	glist.item.contentTemplate = ch.Artwork;				// OPTIONS: ch.Artwork / ch.Text / ch.Artwork_and_Text / ch.Artwork_or_Text / ch.Flyer_and_Artwork 
	glist.item.count = 7; 									// OPTIONS: Total number of gamelist items to display
       
	glist.item.sizeScaling.low = 1.00; 						// OPTIONS: 0-100 Scaling size percentage to use for the item furthest from the selected item 
	glist.item.sizeScaling.high = 1.00; 					// OPTIONS: 0-100 Scaling size percentage to use for item closest to the selected item
	glist.item.sizeScaling.currentlySelected = 1.00;		// OPTIONS: 0-100 Scaling size percentage to use for the currently selected item
       
	glist.item.alphaScaling.low = 255; 						// OPTIONS: 0-100 Scaling size percentage to use for the item furthest from the selected item 
	glist.item.alphaScaling.high = 255; 					// OPTIONS: 0-100 Scaling size percentage to use for item closest to the selected item
	glist.item.alphaScaling.currentlySelected = 255;		// OPTIONS: 0-100 Scaling size percentage to use for the currently selected item
       
	glist.item.height = 140; 								// OPTIONS: Height of each gameList item in pixels before scaling - dynamic with linear vertical lists
	glist.item.width = 140;									// OPTIONS: Width of each gameList item in pixels before scaling - dynamic with linear horizontal lists
       
	if ( my_config["logob"] == "No Border" )
	{
		glist.item.margin.left = 0; 						// OPTION: bounding box left margin size for all images and text 
		glist.item.margin.right = 0; 						// OPTION: bounding box right margin size for all images and text
		glist.item.margin.top = 0;							// OPTION: bounding box top margin size for all images and text
		glist.item.margin.bottom = 0;						// OPTION: bounding box bottom margin size for all images and text
       
		glist.item.toggle.backgroundColor = false;			// if set to "TRUE" the game item background can be colored (use item.normal.color)
		glist.item.toggle.backgroundFile = false;			// if set to "TRUE" the game item will use a file as the background (file: item_backgroundFile.png)
		glist.item.toggle.selectedBackgroundColor = false; 	// if set to "TRUE" the selected game item background can be colored (use item.currentlySelected.color)
		glist.item.toggle.selectedBackgroundFile = false;	// if set to "TRUE" the selected game item will use a file as the background (file: item_selectedBackgroundFile.png)
		glist.item.toggle.glossOverlay = false;				// if set to "TRUE" will overlay the game item with a gloss file (file: item_glossOverlay.png)
		glist.item.toggle.borderOverlay = false;			// if set to "TRUE" will overlay the game item with a boarder file (file: item_borderOverlay.png)
	}	
	if ( my_config["logob"] == "Border" )
	{
		glist.item.margin.left = 5; 						// OPTION: bounding box left margin size for all images and text 
		glist.item.margin.right = 5; 						// OPTION: bounding box right margin size for all images and text
		glist.item.margin.top = 15;							// OPTION: bounding box top margin size for all images and text
		glist.item.margin.bottom = 15;						// OPTION: bounding box bottom margin size for all images and text
       
		glist.item.toggle.backgroundColor = false;			// if set to "TRUE" the game item background can be colored (use item.normal.color)
		glist.item.toggle.backgroundFile = true;			// if set to "TRUE" the game item will use a file as the background (file: item_backgroundFile.png)
		glist.item.toggle.selectedBackgroundColor = false; 	// if set to "TRUE" the selected game item background can be colored (use item.currentlySelected.color)
		glist.item.toggle.selectedBackgroundFile = true;	// if set to "TRUE" the selected game item will use a file as the background (file: item_selectedBackgroundFile.png)
		glist.item.toggle.glossOverlay = false;				// if set to "TRUE" will overlay the game item with a gloss file (file: item_glossOverlay.png)
		glist.item.toggle.borderOverlay = true;				// if set to "TRUE" will overlay the game item with a boarder file (file: item_borderOverlay.png)
	}	
	glist.item.normal.color.red = 0;						// OPTIONS: background red color channel 0 - 255
	glist.item.normal.color.green = 255;               		// OPTIONS: background green color channel 0 - 255
	glist.item.normal.color.blue = 255;                		// OPTIONS: background blue color channel 0 - 255
       
	glist.item.currentlySelected.color.red=0;				// OPTIONS: background red color channel 0 - 255
	glist.item.currentlySelected.color.green=128;      		// OPTIONS: background green color channel 0 - 255
	glist.item.currentlySelected.color.blue=128;       		// OPTIONS: background blue color channel 0 - 255
             
	glist.artwork.type = "wheel"; 							// OPTIONS: name of the artwork to use for the conveyour
	glist.artwork.type2 = "snap";							// OPTIONS: name of the artwork to use for the conveyour setting "Flyer_and_Artwork"
	glist.artwork.preserveAspect = false;					// OPTIONS: true / false
//  glist.add_favoriteImage(fe.script_dir + "favorite.png",vList.item.width -30,0,30,25);
		
	glist.show();
}

// Simple Game List

if ( my_config["gamelist"] == "Simple" )
{
	local lb = fe.add_listbox( 560, 60, 140, 365 );
		lb.charsize = 15;
		lb.rows = 9;
		lb.set_rgb( 255, 255, 255 );
		lb.set_sel_rgb( 255, 0, 0 );
		lb.selbg_alpha = 0;

	local lb = fe.add_listbox( 36, 143, 200, 300 );
		lb.charsize = 15;
		lb.rows = 9;
		lb.set_rgb( 255, 255, 255 );
		lb.set_sel_rgb( 255, 0, 0 );
		lb.selbg_alpha = 0;

	local lb = fe.add_listbox( 40, 139, 200, 300 );
		lb.charsize = 15;
		lb.rows = 9;
		lb.set_rgb( 255, 255, 255 );
		lb.set_sel_rgb( 255, 0, 0 );
		lb.selbg_alpha = 0;

	local lb = fe.add_listbox( 40, 143, 200, 300 );
		lb.charsize = 15;
		lb.rows = 9;
		lb.set_rgb( 255, 255, 255 );
		lb.set_sel_rgb( 255, 0, 0 );
		lb.selbg_alpha = 0;

	local lb = fe.add_listbox( 38, 141, 200, 300 );
		lb.charsize = 15;
		lb.rows = 9;
		lb.set_sel_rgb( 241, 228, 62 );
		lb.set_selbg_rgb( 45, 64, 154 );
		lb.selbg_alpha = 0;
}

fe.add_artwork( "snap", 45, 64, 467, 360 );
fe.add_image( "glbg.png", 0, 0, 720, 480 );

local gamenum = fe.add_text("[ListEntry] / [ListSize] ",566,428,136,34);
	gamenum.set_rgb( 255, 255, 255 );
local gamenum = fe.add_text("[ListEntry] / [ListSize] ",566,432,136,34);
	gamenum.set_rgb( 255, 255, 255 );
local gamenum = fe.add_text("[ListEntry] / [ListSize] ",570,428,136,34);
	gamenum.set_rgb( 255, 255, 255 );
local gamenum = fe.add_text("[ListEntry] / [ListSize] ",570,432,136,34);
	gamenum.set_rgb( 255, 255, 255 );
local gamenum = fe.add_text("[ListEntry] / [ListSize] ",568,430,136,34);
	gamenum.set_rgb( 183, 5, 0 );

// Game select sound

function select_sound( ttype, var, ttime ) {
 switch ( ttype ) {

  case Transition.ToNewSelection:
	      local sound = fe.add_sound("glclick.mp3");
	      sound.playing=true;
  break;
  }
 return false;
}
fe.add_transition_callback( "select_sound" );
